@ECHO OFF
SETLOCAL
REM Changes the AM Database support DLL 
REM (c) Intelligent Environments Ltd 1990
IF "%1%" == "" GOTO :USAGE
IF %1 == SS GOTO :SSINST
IF %1 == ss GOTO :SSINST
IF %1 == EE GOTO :EEINST
IF %1 == ee GOTO :EEINST
GOTO :USAGE

:SSINST
SET SERVNAME=SQL Server
SET DLLNAME=AMSQLSS.DLL
ECHO Installing %SERVNAME% support DLL
IF NOT EXIST AMSQLSS.DLL GOTO :NODLL
COPY AMSQLSS.DLL AMSQL.DLL > NUL
IF ERRORLEVEL 1 GOTO :FAILED
GOTO :SUCCEED

:EEINST 
SET SERVNAME=Database Manager
SET DLLNAME=AMSQLEE.DLL
ECHO Installing %SERVNAME% support DLL
IF NOT EXIST AMSQLEE.DLL GOTO :NODLL
COPY AMSQLEE.DLL AMSQL.DLL > NUL
IF ERRORLEVEL 1 GOTO :FAILED
GOTO :SUCCEED

:NODLL
ECHO Cannot find %SERVNAME% support DLL %DLLNAME%
ECHO %SERVNAME% support was NOT installed.
GOTO :SUGGEST

:FAILED
ECHO Cannot copy %SERVNAME% support DLL %DLLNAME%
ECHO %SERVNAME support was NOT installed.
:SUGGEST
ECHO Ensure that the current directory is the directory on which AM was installed.
ECHO Ensure that AM is NOT running.
GOTO :END

:SUCCEED
ECHO %SERVNAME% support successfully installed.
GOTO :END

:USAGE
ECHO Usage: AMSQLUSE SS - Installs SQL Server support
ECHO        AMSQLUSE EE - Installs Database Manager support
GOTO :END

:END
ENDLOCAL

